Introduction

WML is a markup language based on XML and is intended for use in specifying content and user interface for narrowband devices, including cellular phones and pagers.

WML is designed with the constraints of small narrowband devices in mind. These constraints include:

  • Small display and limited user input facilities

  • Narrowband network connection

  • Limited memory and computational resources

WML includes four major functional areas:

  • Text presentation and layout

  • Deck/card organizational metaphor

  • Inter-card navigation and linking

  • String parameterization and state management

By using WAPPage 2.0 design tool, the user can create WML Pages even without having prior knowledge about WML. It facilitates the user to create their own WML Pages just by clicking on the buttons available.

The WML Pages thus created, can be previewed and checked for its functionality with the help of WAPPage Emulator 2.0. This Emulator can also be used as a browser for WML sites.


WAPPage 2.0

WAP Page is a WYSIWYG (What You See Is What You Get) WML design tool and editor. By using this tool, WML Pages can be created with ease. WML Pages can be created either by manually typing WML code in the Code View of the editor or by just dragging and dropping WML Controls available in the Design bar. WML Controls placed in the Design view will be reflected in the Code View and vice versa. The XML Tree View gives the tree view of the WML page created.

A WML page can also be called a WML deck. A WML deck comprises of one or more WML Cards. Addition of new WML cards within a WML deck is possible both from the Design view and the Code view. Similarly, all the other WML Controls i.e., WML tags can be inserted both from the Design and Code view. Properties can be set accordingly.

The WML Controls can be listed as:

A Element

Select

Input

Text

Option

Image

Optgroup

Card

Para

The Code generation will be done automatically if the WML file is created only from the Design View. Any errors detected during compilation will be displayed in the Output Window. Re-alignment and Deletion of the controls in the Design View will be reflected in the Code view.


Emulator

WAPPage Emulator 1.0

WAPPage Emulator is a browser, exclusively meant for browsing through WML pages and WML sites. It is an added feature of WAPPage 2.0. It helps in previewing the WML files created using WAPPage 2.0. Like all other browsers, WAPPage Emulator supports the basic browser functionalities. To list them, Navigating to a particular site, Back, Forward, Home, Reload, Stop and Search operations. Unlike all other browsers, WAPPage Emulator helps in navigating WML sites only.


'A' Element

Element A

The A Element is available as an icon in the Design bar and also as a menu item in the WML Controls Menu. When the user is in the Design view, they can click on the A Element icon or the A Element menu item. Then by clicking on the Design view, they can insert an A Element. By right clicking on the A Element, a properties popup menu will appear. Properties can be set accordingly. When the user is in the Code view, the above operation will generate a properties dialog box, which enables the user to set the properties accordingly. After which the A Element tag is inserted at the current cursor position in the Code View.

You Can Set and Get the properties to the Anchor element as shown below:

Property | Description
Title | This attribute specifies a brief textString identifying the link. The user agent may truncate or ignore this attribute depending on the characteristics of the navigational user interface. To work well on broad range of user interface, the author should limit all labels to 6 characters in length.
Text | This attribute specifies the text to be displayed for the corresponding <A> tag
URL | This attribute specifies the destination URL.
xml:lang | This attribute specifies the natural or formal language of an element.


Card

WML pages are called DECKS. They are constructed as a set of CARDS, related to each other with links. When a WML page is accessed from a mobile phone, all the cards in the DECK are downloaded from the WAP server. The phone computer, inside the phone, does navigation between the cards without any extra access trips to the server.

A WML card can be set up

  • to display the table functions of WML table element

  • to display the anchor functions of WML using anchor or A element

  • to display images using Image element

  • to let a user enter information using Input element

  • to display the select and option functions of WML using Select and Option elements

  • to display the fieldset function of WML using Fieldset elements

  • to use the timer function of WML using Timer element

  • to define various kinds of tasks like Go,Noop,Prev and Refresh

  • to define a triggering event using Do element

When a WML file is opened, the card(s) associated with it is/are displayed in the Card Pane of the Design Window. Double clicking on a particular card, displays all the WML elements within the card in the Control Pane of the Design Window. The Code and XML Tree view displays the respective code and tree view of the selected card. The user is allowed to edit the Card elements, the Card properties and the Card Task properties either from the Design view or from the Code view.

Property | Description
ID | This attribute provides the control an unique name within a single deck.
Title | This attribute specifies title for this control, which will be displayed on the screen.
OnEnter Backward | The OnEnter Backward event occurs When the user causes the user agent to Navigate into a card using a prev task or any method with identical semantics. In other words, the on enter backward event occurs when the user causes the user agent to navigate into a card by using a URL retrieved from the history stack. This includes navigation caused by stack and mechanisms.
OnEnter Forward | The OnEnter Forward event occurs when the user causes the user agent to enter the card using a go task or any method with identical semantics. This includes card entry caused by a script function or user-agent specific mechanisms, such as a means to directly enter and navigate to url.
On Timer | The OnTimer events occur when a timer expires. Timers are specified using the timer element.
xml:lang | This attribute specifies the natural or formal language of an element.
Class | The attribute class affiliates an element with one or more class. Multiple elements can give the same class name.
Ordered Card | This attribute specifies a hint to the user agent about the organization of the card content. This hint may be used to organize the content presentation or to otherwise influence the layout of the card.
New Context | This attribute indicates that the current browser context should be re-initialized up on entry to this card.
Timer Name | This attribute indicates that the current browser context should be re-initialized up on entry to this card.
Value | This attribute indicates the default value of the variable name in the named attribute.

You Can Set and Get the properties to the Task element as shown below:

Property

Description

Do events

The Do element may appear at both card level and deck level.

ID

This attributee provides an element a unique name within a single Deck.

Type

This attribute provides a hint to the user agent about the author's intended use of the element and how the element should be mapped to a physical user interface construct.

xml:lang

This attribute specifies the natural or formal language of an element.

Class

The attribute class affiliates an element with one or more classes. Multiple elements can give the same class name.

Label

The user agent may be able to dynamically label the user interface widget. This attribute specifies a Textual string suitable for such labeling.

Name

This attribute specifies the name of the do Binding.

Task Type

Prev: Declares a previous task, indicating navigation to the previous URL on the history stock.

Refresh: Declares a refresh task, indicating an update of the user agent context as specified by the setvar elements.

Noop: specifies nothing should be done.

Go: the target url is identified and fetched by the user agent. The destination card is located using the name located in the url.

SetVar: This element is specified by the variable to set in the current browser context.

Postfield: This element specifies the name and value on the origin server during the url request

Accept-charset

This attribute specifies the list of character encoding for data that the originating server must accept when processing input.

Method-get

The submission data is added to the query component of the URL.

Method-post

The submission data is sent to the origin server with an HTTP POST operation.

Right clicking on a particular Card from the Card Pane invokes a popup menu with New Card, Properties, and Delete options. Selection of New Card inserts a card named "No Name" in the Card Pane. Selection of Properties invokes a properties dialog box, which the user can set the Card properties and the Card Task properties. Various card tasks like Go, Noop, Prev and Refresh can be defined using Card Task properties. Selection of Delete deletes the selected Card after displaying a confirmation of the delete operation. A WML file should have at least one card within it. Delete option is disabled when there is only one card.

If you select the "OK" option, the card will be deleted from the editor.


Card Pane

When an exiting file is opened or a new file is created, the Designer Window will be divided vertically into two panes. The left pane is the card pane and it contains three pages: Design, Code, and XML Tree. In the Design page the names of the cards in the file will be displayed. The XML code of the file will be displayed if you select the Code page. You can edit the code manually and then compile it by selecting the compile icon in the Tool Bar. When you select the tree page, the file will be displayed as an inverted tree.


Code Generation

In the WAPPage Editor, the code for each file (which may contain one or more cards) is automatically generated when the user switches between Design and Code view or Tree view or vice versa. Any errors found, will be displayed in the Output Window. The type of error, its description and its location within the code (line number and its position in the line) will be indicated. Only switching to code view in the design window and deleting the invalid code can remove the error.


Control Pane

When an existing WML file is opened or a new WML file is created, the Design Window will be divided vertically into two panes. The left pane is the Card Pane. The right pane is the Control Pane where WML controls can be placed.


Controls

The WAPPage editor provides the foremost fundamental controls, viz., 'A' Element, Select, Option, Optgroup, Input ,Text, Card, Para and Image. Each control is represented by an appropriate icon in the Design Bar or as a menu item in the WML Controls Menu. These icons get activated only when a file is open in the editor.

A WML control can be placed in the control pane either by clicking an active icon (that is, when a file is open) or by selecting its name from the menu and dropping it anywhere in the control pane area.

NOTE: An Option control can be placed only inside a Select or Optgroup Control. Similarly, an Optgroup control can be placed only inside a Select Control.

If the above said controls are placed at any other place, a message to this effect will be displayed and the control will not be added in the Control Pane.

Right clicking on the respective control will enable a context sensitive menu. Clicking on the "Properties" option enables a dialog box appropriate to the control and the corresponding properties can be set.


Design Bar

This bar is normally docked on the top left of the screen and is dockable to any part of the screen. It contains icons relating to the controls: 'A' Element, Select, Option, Input, Optgroup, Text, Card, Para and Image. When the user is in the Design View, clicking on the icon and then clicking on the Control Pane, will place the control in the corresponding mouse cursor position. When the user is in the Code View, clicking on the icon will enable a properties dialog box of the respective control, after which the corresponding WML control tag is placed in the current cursor position of the code view.


Design Window

WML pages can be visually designed in this window by placing the various controls available in the editor. The Design Window consists of 3 panes.

Design View

Code View

XML TreeView

Further the Design view has 2 panes. The Card Pane is dedicated to the cards and the Control Pane is dedicated to all the design controls used for designing the WML Pages. A typical scenario of creating a file using this tool is depicted below pictorially.

Design View:

When a Control is selected either from the Design Bar or from the WML Controls Menu and dropped in the Design Window, its visual representation can be viewed. The picture shown below shows a typical scenario of placing 'Select' and 'Text' controls. You can see the code changes for these controls in the code view.

Code View:

Code View shows the corresponding WML code for the corresponding WML file designed. The Code changes done will be reflected in the Design view immediately. If the code manually typed by the user contains an error, the error is displayed in the Output window.

XML Tree View:

This View gives an effective representation of the WML File in a tree structure. This view will be useful for the developer who can quickly visualize the code of a typical WML file. This tree is generated only if the code is free of compilation errors.


Download

WML Projects and WML Files available on a FTP Server location can be downloaded into the user's local machine.

Download can be selected from the Tools menu or from the Toolbar.

Click on Download to get a Download Dialog box. FTP server name, username and password are to be entered. Enter Destination Path or click on the Browse button (&ldots;) to select a folder from the Select Folder Dialog box. Click on Source button to select the folder in the Server from which the files are to be downloaded.

The list of files is displayed in the Select File(s) list box. When Select All checkbox is checked, the list box is disabled. When unchecked, the list box is enabled to facilitate the user to select the file(s) that are to be downloaded.

When OK is pressed, the status of the download operation is shown via a progress bar.


File

Each WML file generated through the editor can be saved with the extension ".wml". A file represents the WML card (s). When File–>New File menu item or New icon is clicked, a sub-menu pops up with ASP, JSP and WML sub-menu items. This enables the user to create and edit ASP and JSP files apart from our regular WML files. When ASP or JSP is selected, only the Code view is available for the user, where the user can create and edit ASP and JSP code. When WML is selected, a new file is created and opened for the user and the user's focus will be on the Design View. The current WML file will be saved when the user switches between Design and Code view or XML view or vice versa.

A WML file is opened from File–>Open menu or using Open icon. All the cards embedded in the file is available in the Card Pane of the Design window. A file can be retrieved at any time and modified through the editor both from the Design view and the Code view.


Image

Images can be inserted from both the Design View and Code View. When the user is in the Design View, clicking on the Image icon in the Design bar or on the Image menu item in the WML Controls menu, displays an Open dialog box, for the user to select the corresponding .wbmp file. If OK is pressed the corresponding .wbmp file is inserted in the Design window. If Cancel is pressed, the default image is inserted in the Design window. When the user is in the Code View, clicking on the Image icon or on the Image menu item enables a properties dialog box, using which the user can set the properties for the Image. Closing of the dialog box inserts the image tag at the current cursor position of the Code view.

Property

Description

Alt

This attribute specifies an alternative textual representation for the image. This representation is used when the image cannot be displayed using any other method ie, the user agent does not support images, or the image contents can not be found).

Src

This attribute specifies the URI for the image. If the browser supports images, it downloads the image from the specified URL and renders it when the text is being displayed.

Local src

This attribute specifies an alternative internal representation for the image.This representation is used if it exists;otherwise the image is downloaded from the URI specified in the src attribute, ie,any local src parameter specified takes precedence over the image specified in the src parameter.

Vspace, Hspace

These attributes specify the amount of white space to be inserted to the left and right (hspace) and above and below(vspace) an image or object.

Height,Width

These attributes give user agents an idea of the size of an image or object so that they may reserve space for it and continue rendering the card while waiting for the image data.

Align

This attribute specifies image alignment within the text flow and with respect to the current insertion point. Align has three possibleValues.

Bottom: means that the bottom of the image should be vertically aligned with the current baseline. This is the default value.

Middle: means that the center of the imageshould be vertically aligned with the center of the current text line.

Top: means that the top of the image should be vertically aligned with the top of the current text line.


Input

The Input element specifies a text entry object. Input can be inserted both from the Design and Code View. While inserting an Input from the Code View or by right clicking on the Input control from the Design View, will enable a properties dialog box, whereby the Input properties can be set.

Property | Description
Name | The name attribute specifies the name of the variable to set with the result of the user's text input.
Title | This attribute specifies title for this Control, and this will be displayed on the screen.
Value | This attribute indicates the default value of the variable named in the name attribute. When the element is displayed and the variable named in the name attribute is not set, the name variable is assigned the value specified in the value attribute.
Format | This attribute specifies an input mask for user input entries.
Class | The attribute class affiliates an element with one or more classes. Multiple elements can give the same class name.
xml:lang | This attribute specifies the natural or formal language of an element.
Type Text | A text entry control. User agents should echo the input in a manner appropriate to the user agent and the input mask. If the submitted value conforms to an existing input mask, the user agent must store that input unaltered and in its entirety in the variable named in the name attribute.
Type-Password | The attribute is a text entry control. Input of each character should be echoed in an obscured or illegible form in a manner specified by the user agent.
Tab Index | This attribute specifies the tabbing position of the current element. The tabbing position indicates the relative order in which the elements are traversed when tabbing within a single WML card.
Size | This attribute specifies the width in characters, of the text input area. The user agent may ignore this attribute.
Max Length | This attribute specifies the maximum number of character that can be entered by the user in the text entry area.


Main Screen

The Main Screen normally contains Project Window, Design Window and Output Window. When a WML file is opened, the Design Window is split into Card Pane and Control Pane. The cards relating to the file are shown in the Card Pane and the WML controls relating to the card are displayed in the Control Pane.

The Main Screen also contains the Menu Bar, the Tool Bar and the Design Bar. Normally, they appear at the top of the screen and are dockable.


Menu Bar

This is normally docked at the top of the screen; however, you can drag and place it anywhere on the screen. You can also change its shape or dock it on any side of the screen. This Bar contains the following Menu options:

  • File

  • Edit

  • View

  • Project

  • WML Control

  • Tools

  • Window and

  • Help

The first three menus contain normal Windows options; Project contains only one option, viz., "Add Files". WML Controls contain the list of controls and the Tools contains the following options:

  • Compile

  • Invoke the Emulator and

  • User Preferences.


Optgroup

This element forms part of a Select element. Any number of Optgroup elements can be placed inside a Select element. When the user is in Design view, clicking on the Optgroup icon or the Optgroup menu item and then clicking on the Design view inside a Select will insert an Optgroup element. If clicked outside Select or clicked over any other control other than Select, a pop up message will appear stating, "Optgroup can be placed inside Select". But, in Code view, the above operation leads to the insertion of an Optgroup tag in the current cursor position.

Property | Description
Title | This attribute specifies a title for this element.
Xml:lang | This attribute specifies the natural or formal language of an element.
ID | This attribute provides an element a unique name within a single deck

When an Optgroup element is right clicked, a context sensitive menu will appear beside it. If Delete is selected, the Optgroup control is deleted.. If Properties is selected, the Properties dialog box appears and the user can set and get the properties of the Optgroup element.


Option

This element forms part of a Select element or an Optgroup element. Any number of options can be placed inside a Select or Optgroup element. When the user is in Design view, clicking on the Option icon or the Option menu item and then clicking on the Design view inside a Select or Optgroup will insert an Option element. If clicked outside Select or Optgroup or clicked over any other control other than Select or Optgroup, will bring up a pop up message saying, "Option can be placed inside Select or Optgroup". But, in Code view, the above operation leads to the insertion of an Option tag in the current cursor position.

Property | Description
Text | This attribute specifies the text to be displayed for the corresponding <A> tag. The text entered in the field will be displayed on the screen.
Title | This attribute specifies a title for this element.
Value | This attribute indicates the default value of the variable named in the name attribute. When the element is displayed and the variable named in the name attribute is not set, the name variable is assigned the value specified in the value attribute.
OnPick | The OnPick event occurs when the user selects or deselects the item.
xml:lang | This attribute specifies the natural or formal language of an element.
ID | This attribute provides an element a unique name within a single deck

When an Option element is right clicked, a context sensitive menu will appear beside it. If Delete is selected, the Option control is deleted.. If Properties is selected, the Properties dialog box appears and the user can set and get the properties of the Option element.


Output Window

This window appears at the bottom of the screen and shows the compilation errors. The Output Window can be closed by clicking the "Error on/off" icon (the icon with the picture of a hammer in it) in the Tool Bar. Clicking on the icon again, makes the window to reappear.


Para

Para icon and menu items are enabled for the user only in the Code view. Since, they don't have any design representation, they are disabled when the user is in the Design view.

While a user in Code view, click on the Para icon or menu item will directly insert a Para tag at the current cursor position.


Project

The WML Project along with its WML files is displayed in the Project Window. The Project will be saved with the extension ".wpg". While adding a WML file to a WML Project, the basic criteria is that, the file should exist in the same directory path as that of the Project.

A Project can be created using File–>New Project menu and an existing Project can be opened using File–>Open Project menu. The Project along with its WML files will be displayed in the Project Window.The Project will be saved with the extension ".wpg". One or more WML files present in the same directory path as that of the Project can be added in the Project using Project–>Add Files to Project. Similarly, one or more WML files can be deleted from a Project using Project–>Delete File from Project. An open Project can be closed using File–>Close Project. While adding a WML file to a Project, the criteria is that, the file should be existing in the same directory path as that of the Project. Failure of which, results in an error message.


Project Window

This window appears on the top left part of the screen. The details of the active Project and the corresponding WML files that are added to the Project are displayed in the Project Window as an inverted tree. The name of the Project with the word "Project" prefixed to it appears as the root of the tree. The WML files relating to the Project appear as leaves. When a WML file is selected, it is opened in the Card Pane of the Design Window and its controls are displayed in the Control Pane.


Select

A Select can have one or more Options and Optgroups nested inside it. When the user is in the Design view, click on the Select icon or the Select menu item and then click on the Design view which will splash a message saying, "Do you want Select with Option or Optgroup? Choose Yes for Option and No for Optgroup". If Yes is chosen, Select with an Option is inserted. If No is chosen, Select with an Optgroup embedded with an Option is inserted. Right click on Select or Optgroup or Option and select Properties to set their respective properties. The user can insert as many Optgroups or Options inside A Select and can insert as many Options inside an Optgroup.

When the user is in the Code View, click on the Select icon or Select menu item. This will pop up a properties dialog box, after which a Select tag (nothing embedded inside) gets inserted at the current cursor position in the Code View. The user can then embed one or more Optgroups or Options following the same procedure for insertion.

Select should have at least one Optgroup or Option embedded within it according to the DTD scheme given by WapForum.

Property | Description
Name | This attribute indicates the name of the variable to set with the result of the selection.
Title | This attribute specifies a title for this element. This will be displayed on the screen.
TabIndex | This attribute specifies the tabbing position of the current element. The tabbing position indicates the relative order in which the elements are traversed when tabbing within a single WML card.
ID & Class | All WML elements have two core attributes:id and class that can be used for such tasks as server transformation. The Id attribute provides an element a unique name within a single deck. The attribute class affiliates an element with one or more classes. Multiple elements can give the same class name. All elements of a single deck with a single class name are considered to be part of the same class.
Value | This attributeindicates the default value of the variable named in the name attribute. When the element is displayed and the variable named in the named attribute is not set, the name variable is assigned the value specified in the value attribute.
iName | This attribute indicates the name of the variable to be set with the index result of the selection. The index result is the position of the currently selected option in the select list. An index of 0 indicates that no option is selected. Index numbering begins at 1 and increases monotonically.
iValue | This attribute indicates the default-selected option element. If the variable named in the iName attribute is not set, when the control is displayed. it is assigned the default-selected entry. If the variable already contains a value, the iValue attribute is ignored. If the iName attribute is not specified, the iValue value is applied every time the element is displayed.
xml:lang | This attribute specifies the natural or formal language of an element.


Text

This is an element used to display a text in the WML Page. Clicking on the Text icon in the Design Bar or Text menu item in the WML Controls menu inserts a Text element in the Design view or the Code view, depending upon the view, in which, the user is currently in. Right clicking on the control in the Design view or clicking on the Text icon or Text menu item from the Code view enables a properties dialog box, using which the user can set the Text properties.

Property | Description
Emphasis | Render with Emphasis.
Strong | Render with Strong emphasis.
Italics | Render with an Italic font.
Underline | Render with Underline.
Big | Render with a Large font.
Normal | Render with a Normal font.
Small | Render with a Small font.


Tool Bar

The Tool Bar contains the Standard Windows icons. Normally it is docked at the top of the screen below the Menu Bar. However, it is dockable to any part of the screen.

Apart from the normal Windows icons like New, Open, Save, Print etc., it also contains icons to close or open the project window and the output window. Clicking on the Full Screen icon displays only the Card and Control panes. (To return to the normal mode, select the icon that appears on full screen mode or by pressing "Esc" key). The Compile icon compiles the code. The About icon displays a message box. This contains information about the WAPPage 2.0.


Upload

WML Projects and WML Files can be uploaded on to a FTP location.

Upload can be selected either from the Tools menu or from the Toolbar. It is enabled only when the project file is open. Click on Upload to get an Upload Dialog box. FTP Server name, Username and Password is to be entered. Destination Folder can be either entered manually or chosen from the Select Folder dialog box by clicking the Browse button (&ldots;).

Select File(s) list box contains the list of files available in the project. If the Project Radio button is checked, the list box is disabled so that all the files in the Project will be uploaded. If the File Radio button is checked, the list box is enabled to facilitate the user to select the files that are to be uploaded.

All the input fields are mandatory fields. If File Radio button is checked and no file from the list is selected, a message pops up saying, "Select File(s) from the File List".

When OK is pressed, the status of the upload operation is shown via a progress bar.

Wrong entry of input data will result in an error message.


User Preference

Tools–>User Preference helps the user to set his/her preferences with respect to the font, the color of various parts of WML code and the Local DTD (Document Type Description) Path.

If the user clicks on the Set Defaults button, the font is set to Arial, color of Tags (<select>) to Maroon, color of Comments (<!-->) to Olive, color of Attributes (title=) to Navy, color of Strings ("Welcome") to Green and color of Scripts, in case of ASP and JSP files, to Purple.

If Local DTD Path field is checked, the Local DTD Path field is set with the value "C:\Program Files\Zylog Systems\Wappage\wml_1.1.xml".


Code View Editor

The Code View Editor facilitates syntax highlighting. Preferences with regard to font, coloring of WML tags etc., can be set accordingly

Parser

The XML parses a WML file and reports in the output window.

If there is any error, the parser will report the line number and column number where the error is. The parser can be invoked from Tools -> Compile menu.

WAPPage Emulator

WAPPage Emulator can be invoked to view the WML pages in a WML browser.

Path of the WAPPage Emulator can be set by Preferences.


Tools

Design View Editor

The Design View Editor helps to design WML decks visually. The Design View Editor shows what you will be seeing in the browser. WAPPage facilitates card level design. The UI consists of two parts

  • Cards

  • Content of a card that is currently selected. (Card Pane and Control Pane)

Card Pane

By default, a WML deck will have a card with TITLE "no name". The context sensitive menu of the cards list part shows three items

  • New Card

  • Delete

  • Properties

A new card can be added to the current WML deck using the menu New Card. The menu item Delete removes a card from a WML deck. The properties of a card can be set, modified and deleted using the Properties menu item.

Control view Pane

A card in a WML deck can be designed visually by choosing visual elements for the WML tags from the tool bar. The Control Pane shows the card that is currently selected from the cards list. By default, it shows the first card's visual elements in the Design View Editor. The context menu of the Design view Editor of a card shows three items

  • Delete

  • Align All

  • Properties

The menu item Delete removes a visual element of a WML tag. Align All menu item aligns the controls one below the other in the Design View Editor. The properties of all the visual elements of a card can be set, modified and deleted using the Properties menu item.


WAPPage Emulator

WAPPage Emulator 1.0

WAPPage Emulator is a browser, exclusively meant for browsing through WML pages and WML sites.

Address Bar

Back

Edit

File

Forward

Go

Help

Home

Reload

Search

Status Bar

Stop

Title bar

View

Address Bar:

Type an URL in the Address bar and press Enter or select an URL from the Address bar list. The corresponding page will be rendered. Make sure that the URL given corresponds to a WML site. The URL entered may be a valid URL or a file path. While entering WML file path, prefix the file path with file://. If the URL or the file path entered points to a non-WML site or file, a message is splashed saying, "MIME type incompatibility".

Back:

Back navigates to the previous WML page. Back is disabled when the user is in the first page.

Edit:

Edit Menu contains the normal editing operations as menu items:

  • Redo - redoes the current editing operation

  • Undo - undoes the current editing operation

  • Copy - copies the current selection onto the clipboard

  • Cut - cuts the current selection and puts it onto the clipboard

  • Paste - pastes from the clipboard

  • Select All - selects the current page

  • View Source - displays the WML source code of the current WML page that is rendered.

  • Font - helps the user to change the font size of the page that is rendered.

File:

File Menu contains the standard menu items:

  • New Window - opens a new Browser window

  • Open - provides an Open dialog box for the user to select a WML file, which is to be rendered.

  • Save As - saves the current page as a WML file

Forward:

Forward navigates to the next WML page. Forward is disabled when the user is in the last page.

Go:

Go menu contains the basic navigation operations:

  • Back - navigates to the previous page

  • Forward - navigates to the next page

  • Home - navigates to the home page

  • Search on the Web - navigates to the WML search site

Help:

About Wappage Emulator - gives details about the product.

Home:

Home navigates to the Home page.

Reload:

Reload refreshes the current WML page.

Search:

Search navigates to http://wap.mobone.com. This is a WML search site. Click on Search. Enter the keyword to be searched for. This displays the WML sites containing the keyword.

Status Bar:

Status bar gives the status of navigation to the user while navigating. Both when the navigation operation is in progress and while the navigation is complete and the page is rendered.

Stop:

Stop halts the current navigation operation.

Title bar:

Title bar shows the URL of the WML page that is rendered.

View:

View menu contains:

  • Toolbar - if unchecked, makes the toolbar to disappear.

  • Status bar - if unchecked, makes the status bar to disappear.

  • Stop - Stops the current navigation

  • Refresh - Reloads the current page


WML Reference Guide

WML Guide

<a>
<access>
<anchor>
<b>
<big>
<br>
<card>
<do>
<em>
<fieldset>
<go>
<head>
<i>
<img>
<input>
<meta>
<noop>
<onevent>
<optgroup>
<option>
<p>
<postfield>
<prev>
<refresh>
<select>
<setvar>
<small>
<strong>
<table>
<td>
<template>
<timer>
<tr>
<u>
<wml>


WML tag: <a>

<a>

List of tags

Summary:
Specifies that the text within the tags a hyperlink. The destination of a link is specified as a URI: the address or ID of another tag. Authors are encouraged to use the <a> tag instead of anchor where possible. It is invalid to nest anchor tags. The <a> tag is a short form of the anchor tag; it is essentially bound to a go task without variables.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
href | HREF |  |  | Specifies the destination URI
title | String | X |  | Specifies a brief text string identifying the link

Nested tags:
<br> <img>


WML tag: <access>

<access>

Summary:
Specifies access control information for the entire deck. It is an error for a deck to contain more than one access element. If a deck does not include an access element, access control is disabled. When access control is disabled, cards in any deck can access this deck.

A deck's domain and path attributes specify which other decks may access it. As the browser navigates from one deck to another, it performs access control checks to determine whether the destination deck allows access from the current deck.

If a deck has a domain and/or path attribute, the referring deck's URI must match the values of the attributes. Matching is done as follows: the access domain is suffix-matched against the domain name portion of the referring URI and the access path is prefix matched against the path portion of the referring URI.

Domain suffix matching is done using the entire element of each sub-domain and must match each element exactly (e.g. www.wapforum.org shall match wapforum.org, but shall not match forum.org).

Path prefix matching is done using entire path elements and must match each element exactly (e.g. /X/Y matches /X in the attribute, but does not match /XZ in the attribute).

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
domain | String | X | Current deck's domain | The domain suffix of allowed referring pages.
path | String | X | / | The path prefix of allowed referring pages.


WML tag: <anchor>

<anchor>

Summary:
Specifies that the text within the tags a hyperlink. The destination of a link is specified as a URI: the address or ID of another tag. Authors are encouraged to use the <a> tag instead of anchor where possible. It is invalid to nest anchor tags.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
title | String | X |  | Specifies a brief text string identifying the link

Nested tags:
<br> <img> <go> <prev> <refresh>


WML tag: <b>

<b>

Summary:
Indicates that the text within the tags should be rendered with bold formatting. Authors should attempt to use the strong and em tags in place of the b, <i> and <u> tags, except where explicit control over text presentation is required.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <strong> <i> <u> <big> <small> <br> <img> <anchor> <a> <table>


WML tag: <big>

<big>

Summary:
Indicates that the text within the tags should be rendered with a large font.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <strong> <b> <i> <u> <small> <br> <img> <anchor> <a> <table>


WML tag: <br>

<br>

Summary:
Ends the current line and starts a new line. Should also be supported within tables.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes


WML tag: <card>

<card>

Summary:
A WML deck contains a collection of cards. The card element is a container of text and input elements that is sufficiently flexible to allow presentation and layout in a wide variety of devices, with a wide variety of display and input characteristics. A card can contain markup, input fields and elements indicating the structure of the card.

A card's id may be used as a fragment anchor.

Attributes:
Name | Data type | Mandatory | Default | Description
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
title | String | X |  | Specifies advisory information about the card. The title may be rendered in a variety of ways by the browser (suggested bookmark name, pop-up tooltip, etc.)
newcontext | Boolean | X | FALSE | Indicates that the current browser context should be re-initialised upon entry to this card
ordered | Boolean | X | TRUE | Specifies a hint to the browser about the organisation of the card content. May be used to organise the content presentation or to otherwise influence layout of the card
onenterforward | HREF | X |  | The URI that is loaded when the user navigates into the card using a go task
onenterbackward | HREF | X |  | The URI that is loaded when the user navigates back into the card using a prev task
ontimer | HREF | X |  | The URI that is loaded when the timer expires

Nested tags:
<do> <onevent> <timer> <p>


WML tag: <do>

<do>

Summary:
The <do> tag provides a general mechanism for the user to act upon the current card. The representation of the <do> tag is dependent on the device and the author must only assume that the tag is mapped to a unique user interface widget, such as a button, that the user can activate.
The <do> tag may appear at both the card and deck-level:

* Card-level: the <do> tag may appear inside a card tag and may be located anywhere in the text flow.

* Deck-level: the <do> tag may appear inside a deck template, indicating a deck-level <do> tag. A deck-level <do> tag applies to all cards in the deck, and is equivalent to having specified the do within each card. For the purposes of rendering, the browser must behave as if deck-level <do> tags are located at the end of the card's text flow.

A card-level <do> tag overrides (or "shadows") a deck-level <do> tag if they have the same name. For a single card, the active <do> tags are defined as the <do> tags specified in the card, plus any <do> tags specified in the deck's template and not overridden in the card.

Non-active <do> tags and active <do> tags with a noop task are not displayed. All active <do> tags with a task other than noop will be shown in some manner. When the user activates the <do> tag, the associated task is executed.

Attributes:
Name | Data type | Mandatory | Default | Description
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
type | String |  |  | Provides a hint to the browser about the author's intended use of the tag and how the tag should be mapped to the physical user interface: 'accept' (positive acknowledgement); 'prev' (backward history navigation); 'help' (request for help); 'reset' (clearing or resetting state); 'options' (request for options or additional operations); 'delete' (delete item or choice); 'unknown' a generic do element
label | String | X |  | Specifies a textual string suitable for labelling the user widget. To work well on a variety of browsers, labels should be six characters or shorter in length
name | String | X | Value of type attribute | Specifies the name of the do event binding
optional | Boolean | X | false | If true, the browser may ignore this element

Nested tags:
<go> <prev> <noop> <refresh>


WML tag: <em>

<em>

Summary:
Indicates that the text within the tags should be rendered with some form of emphasis. Authors should attempt to use the em and strong tags in place of the<b>, <i> and <u> tags, except where explicit control over text presentation is required.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:


WML tag: <fieldset>

<fieldset>

Summary:
The fieldset element allows the grouping of related fields and text. This grouping allows the optimizing of layout and navigation. Fieldset elements may nest, providing the author with a means of specifying behavior across a wide variety of devices.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
title | String | X |  | Specifies a title for this element, which may be used in the presentation of this object.

Nested tags:
<em> <strong> <b> <i> <u> <big> <small> <br> <img> <anchor> <a> <table> <input> <select> <do>


WML tag: <go>

<go>

Summary:
Declares a 'go' task, indicating navigation to a new URI. If the URI names a WML card or deck, the execution of the task will cause that item to be displayed. This task executes a 'push' operation on the browser's history stack.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
href | HREF |  |  | Specifies the destination URI
sendreferer | Boolean | X | false | If true, the request for the new URI will contain the URI of the deck containing this task - this can then be used for server-based access control
method | METHOD | X | get | Specifies the HTTP submission method. Possible values are 'POST' (submission data included in request) or 'GET' (submission data appended as a query to the URI requested)
accept-charset | String | X | unknown | Specifies the list of character encodings for data that the origin server must accept when processing input. The value of this attribute is a comma- or space-separated list of character encoding names

Nested tags:
<postfield> <setvar>


WML tag: <head>

<head>

Summary:
The <head> tag contains information relating to the deck as a whole, including meta-data and access control tags.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<access> <meta>


WML tag: <i>

<i>

Summary:
Indicates that the text within the tags should be rendered with italic formatting. Authors should attempt to use the strong and em tags in place of the <b>, <i> and <u> tags, except where explicit control over text presentation is required.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <strong> <b> <u> <big> <small> <br> <img> <anchor> <a> <table>


WML tag: <img>

<img>

Summary:
The <img> tag indicates that an image is to be included in the text flow. Image layout is done within the context of normal text layout.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
alt | String |  |  | An alternative textual representation for the image if it can not be displayed using any other method
src | URI |  |  | This attribute specifies the URI of the image to be shown
localsrc | String | X |  | Specifies an alternative internal representation for the image. If this image exists, the parameter takes precedence over any image specified in the src parameter
vspace | Length | X | Small, non-zero length | Specifies the amount of white space to be inserted above and below the image. If specified as a percentage value, the resulting space is based on the available vertical space, not on the natural size of the image
hspace | Length | X | Small, non-zero length | Specifies the amount of white space to be inserted to the left and right of the image. If specified as a percentage value, the resulting space is based on the available horizontal space, not on the natural size of the image
align | String | X | bottom | Specifies image alignment with respect to the baseline of the text. It has three possible values: 'bottom', 'middle' or 'top'
height | Length | X |  | Specifies the height of the image. If specified as a percentage value, the resulting size is based on the available vertical space, not on the natural size of the image
width | LENGTH | X |  | Specifies the width of the image. If specified as a percentage value, the resulting size is based on the available horizontal space, not on the natural size of the image


WML tag: <input>

<input>

Summary:
The input element specifies a text entry object. The user input is constrained by the optional format attribute.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
name | String |  |  | Specifies the name of the variable to set with the result of the user's text input. The name variable's value is used to pre-load the text entry object. If this value does not conform to the input mask, the browser will unset the variable and attempt to initialise the variable with the value attribute
type | INPUT_TYPE | X | text | Specifies the type of text-input area. The following values are allowed: 'text' (text entry control) or 'password' (a text entry control where each character is displayed in an illegible form, such as with asterisks)
value | String | X |  | The value attribute indicates the default value of the variable named in the name attribute. When the element is displayed and the variable named in the name attribute is not set, the name variable is assigned the value specified in the value attribute. If the name variable already contains a value, the value attribute is ignored. If the value attribute specifies a value that does not conform to the input mask specified by the format attribute, the browser must ignore the value attribute. In the case where no valid value can be established, the name variable is left unset
format | String | X | *M | Specifies an input mask for user input entries. The string consists of mask control characters and static text that is displayed in the input area. The format control characters specify the data format expected to be entered by the user. The format codes are: 'A' (entry of any upper-case, non-numeric character); 'a' (entry of any lower-case, non-numeric character); 'N' (entry of any numeric character); 'X' (entry of any upper-case character); 'x' (entry of any lower-case character); 'M' (entry of any character); 'm' (entry of any character); '*f' (entry of any number of characters where f is one of the above format codes); 'nf' (entry of n characters where n is from 1 to 9 and f is one of the above format codes); '\c' (display the character, c, in the entry field: these characters are considered part of the input's value).
emptyok | Boolean | X | false | Indicates that this input element accepts empty input although a non-empty format string has been specified
size | NUMBER | X |  | Specifies the width, in characters, of the text-input area.
maxlength | NUMBER | X | Infinite | Specifies the maximum number of characters that can be entered by the user in the text-entry area.
tabindex | NUMBER | X |  | Specifies the tabbing position of the current element. The tabbing position indicates the relative order in which elements are traversed when tabbing within a single WML card.
title | String | X |  | Specifies a title for this element, which may be used in the presentation of this object.


WML tag: <meta>

<meta>

Summary:
The meta element contains generic meta-information relating to the WML deck. Meta-information is specified with property names and values. This specification does not define any properties, nor does it define how browsers must interpret meta-data.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
http-equiv | String | X |  | May be used in place of name and indicates that the property should be interpreted as an HTTP header.
name | String | X |  | Specifies the property name. The browser must ignore any meta-data named with this attribute. Servers should not emit WML content containing meta-data named with this attribute.
forua | Boolean | X |  | Specifies that the author intended the property to reach the browser. In the case where the user agent supports the meta-data mechanism, and the property has its forua attribute set to true, the meta-data must be delivered to the browser.
content | String |  |  | This attribute specifies the property value.
scheme | String | X |  | This attribute specifies a form or structure that may be used to interpret the property value. Scheme values vary depending on the type of meta-data.


WML tag: <noop>

<noop>

Summary:
The <noop> tag specifies that nothing should be done - that is, 'no operation'. This can be used in a card to shadow a task that has been specified in a template at the deck level.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member


WML tag: <onevent>

<onevent>

Summary:
The onevent element binds a task to a particular intrinsic event for the immediately enclosing element. For example, specifying an onevent element inside a card element associates an intrinsic event binding with that card element. The browser will ignore any onevent element specifying a type that does not correspond to a legal intrinsic event for the immediately enclosing element.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
type | String |  |  | Indicates the name of the intrinsic event

Nested tags:
<go> <prev> <noop> <refresh>


WML tag: <optgroup>

<optgroup>

Summary:
The optgroup element allows the author to group related option elements into a hierarchy. The browser may use this hierarchy to facilitate layout and presentation on a wide variety of devices.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
title | String | X |  | Specifies a title for this element, which may be used in the presentation of this object.

Nested tags:

<option>


WML tag: <option>

<option>

Summary:
This element specifies a single choice option in a select element.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
value | String | X |  | Specifies the value to be used when setting the name variable. When the user selects this option, the resulting value specified in the value attribute is used to set the select element's name variable. The value attribute may contain variable references, which are evaluated before the name variable is set.
title | String | X |  | Specifies a title for this element, which may be used in the presentation of this object.
onpick | HREF | X |  | The URI that is loaded when the user selects or deselects this option.

Nested tags:
<onevent>


WML tag: <p>

<p>

Summary:
The p element establishes both the line wrap and alignment parameters for a paragraph. If the text alignment is not specified, it defaults to left. If the line-wrap mode is not specified, it is identical to the line-wrap mode of the previous paragraph in the current card. Empty paragraphs (i.e., an empty element or an element with only insignificant white space) will be considered as insignificant and ignored by browsers. If the first p element in a card does not specify a line-wrap or alignment mode, that mode defaults to the initial mode for the card.

The browser will insert a line break into the text flow between significant paragraphs.

Attributes:
Name | Data type | Mandatory | Default | Description
align | TALIGN | X | left | Specifies the text alignment mode for the paragraph. Can be 'left', 'center', or 'right'.
mode | WRAPMODE | X | wrap (or as in previous paragraph) | Specifies the line-wrap mode for the paragraph. 'wrap' specifies breaking text mode and 'nowrap' specifies non-breaking text mode.
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<do> <em> <strong> <b> <i> <u> <big> <small> <br> <img> <anchor> <a> <table> <input> <select> <fieldset>


WML tag: <postfield>

<postfield>

Summary:
The postfield element specifies a field name and value for transmission to an origin server during a URL request. The actual encoding of the name and value will depend on the method used to communicate with the origin server.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
name | String |  |  | Specifies the variable name.
value | String |  |  | Specifies the variable value.


WML tag: <prev>

<prev>

Summary:
The <prev> tag declares a 'prev' task, indicating navigation to the previous URL on the history stack.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<setvar>


WML tag: <refresh>

<refresh>

Summary:
The <refresh> tag declares a refresh task, indicating an update of the screen and device context as specified by the <setvar> tags, for example. User-visible side effects of the state changes (e.g. a change in the screen display) occur during the processing of the refresh task.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<setvar>


WML tag: <select>

<select>

Summary:
The select element lets users pick from a list of options. Each option is specified by an option element. Each option element may have one line of formatted text. Option elements may be organized into hierarchical groups using the optgroup element.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
title | String | X |  | Specifies a title for this element, which may be used in the presentation of this object.
name | String |  |  | Specifies the name of the variable to set with the result of the selection. The name variable's value is used to pre-load the text entry object.
value | String | X |  | Indicates the default value of the variable named in the name attribute. When the element is displayed, and the variable named in the name attribute is not set, the name variable may be assigned the value specified in the value attribute, depending on the values defined in iname and ivalue. If the name variable already contains a value, the value attribute is ignored. Any application of the default value is done before the list is pre-selected with the value of the name variable. If this element allows the selection of multiple options, the result of the user's choice is a list of all selected values, separated by the semicolon character. The name variable is set with this result. Similarly, the value attribute is interpreted as a semicolon-separated list of pre-selected options.
iname | String | X |  | Indicates the name of the variable to be set with the index result of the selection. The index result is the position of the currently selected option in the select list. An index of zero indicates that no option is selected. Index numbering begins at one and increases monotonically.
ivalue | String | X |  | Indicates the default-selected option element. When the element is displayed, if the variable named in the iname attribute is not set, it is assigned the default-selected entry. If the variable already contains a value, the ivalue attribute is ignored. If the iname attribute is not specified, the ivalue value is applied every time the element is displayed. If this element allows the selection of multiple options, the index result of the user's choice is a list of the indices of all the selected options, separated by the semicolon character. The iname variable is set with this result. Similarly, the ivalue attribute is interpreted as a semicolon-separated list of pre-selected options.
multiple | Boolean | X | FALSE | Indicates that the select list should accept multiple selections. When not set, the select list should only accept a single selected option.
tabindex | NUMBER | X |  | Specifies the tabbing position of the current element. The tabbing position indicates the relative order in which elements are traversed when tabbing within a single WML card.
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<optgroup> <option>


WML tag: <setvar>

<setvar>

Summary:
The setvar element specifies the variable to set in the current browser context as a side effect of executing a task. The element must be ignored if the name attribute does not evaluate to a legal variable name at runtime.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
name | String |  |  | Specifies the variable name.
value | String |  |  | Specifies the value to be assigned to the variable.


WML tag: <small>

<small>

Summary:
Indicates that the text within the tags should be rendered with a small font.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <strong> <b> <i> <u> <big> <br> <img> <anchor> <a> <table>


WML tag: <strong>

<strong>

Summary:
Indicates that the text within the tags should be rendered with some form of strong emphasis. Authors should attempt to use the strong and em tags in place of the b, i and u tags, except where explicit control over text presentation is required.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <b> <i> <u> <big> <small> <br> <img> <anchor> <a> <table>


WML tag: <table>

<table>

Summary:
Used together with the <tr> and <td> tags to create sets of aligned columns of text and images in a card. The table tags determine the structure of the columns. The tags separate content into columns, but do not specify column or intercolumn widths.

The number of columns for the row set must be specified by the columns attribute. If the actual number of columns in a row is less than the value specified by the columns attribute, the row will be effectively padded with empty columns. The orientation of the table depends on the language. For left-to-right languages, the leftmost column is the first column in the table. Columns are added to the right side of a row to pad left-to-right tables. Columns are added to the left side of a row to pad right-to-left table.

If the actual number of columns in a row is greater than the value specified by the columns attribute, the extra columns of the row will be aggregated into the last column, such that the row contains exactly the number of columns specified. A single inter-word space will be inserted between two cells that are being aggregated.

The table will be rendered as narrow as possible given the contents. A non-zero width gutter is used to separate each non-empty column.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
title | String | X |  | Specifies a brief text string identifying the table
align | String | X | left | Specifies the layout of text and images (within the columns) as a list of alignment designations - one for each column. Centre alignment is specified with C, left alignment with L, and right alignment with R. If an alignment designation is omitted, the default alignment is applied
columns | NUMBER |  |  | Specifies the number of columns in the table. Must not be zero

Nested tags:
<tr>


WML tag: <td>

<td>

Summary:
The td element is used as a container to hold a single table cell data within a table row. Table data cells may be empty. Empty cells are significant, and must not be ignored. The browser will attempt to deal with multiple line data cells that may result from using images or line breaks.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<img> <anchor> <a> <em> <strong> <b> <i> <u> <big> <small> <br>


WML tag: <template>

<template>

Summary:
The template element declares a template for cards in the deck. Event bindings specified in the template element (e.g. do or onevent) apply to all cards in that deck, although a card element may override the behavior specified in the template element. In particular:

* DO elements specified in the template element may be overridden in individual cards if both elements have the same NAME attribute value.

* Intrinsic event bindings specified in the template element may be overridden by the specification of an event binding in a card element.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
onenterforward | HREF | X |  | The URI that is loaded when the user navigates into a card using a go task
onenterbackward | HREF | X |  | The URI that is loaded when the user navigates back into a card using a prev task
ontimer | HREF | X |  | The URI that is loaded when the timer expires

Nested tags:
<do> <onevent>


WML tag: <timer>

<timer>

Summary:
The timer element declares a card timer that exposes a means of processing inactivity or idle time. The timer is initialized and started at card entry and is stopped when the card is exited. Card entry is any task or user action that results in the card being activated, for example, navigating into the card. Card exit is defined as the execution of any task. The value of a timer will decrement from the initial value, triggering the delivery of an ontimer intrinsic event when it reaches zero. Note that timer resolution and the interaction of the timer with the browser's user interface and other time-based device functionality is implementation dependent.

It is an error to have more than one timer element in a card.

The timer timeout value is specified in units of one-tenth (1/10) of a second. The author should not expect a particular timer resolution and should provide the user with another means to invoke a timer's task. A timeout value of zero disables the timer.

Invoking a refresh task is considered an exit. The task stops the timer, commits its value to the context, and updates the browser accordingly. Completion of the refresh task is considered an entry to the card. At that time, the timer must resume.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
name | String | X |  | Specifies the name of the variable to be set with the value of the timer. The name variable's value is used to set the timeout period upon timer initialisation. The variable named by the name attribute will be set with the current timer value when the card is exited or when the timer expires. For example, if the timer expires, the named variable is set to a value of zero.
value | String |  |  | Indicates the default value of the variable named in the name attribute - that is the timer value. When the timer is initialised and the variable named in the name attribute is not set, the name variable is assigned the value specified in the value attribute. If the name variable already contains a value, the value attribute is ignored. If the name attribute is not specified, the timeout is always initialised to the value specified in the value attribute.


WML tag: <tr>

<tr>

Summary:
The tr element is used as a container to hold a single table row. Table rows may be empty (i.e., all cells are empty). Empty table rows are significant and must not be ignored.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<td>


WML tag: <u>

<u>

Summary:
Indicates that the text within the tags should be rendered with underline formatting. Authors should attempt to use the strong and em tags in place of the <b>, <i> and <u> tags, except where explicit control over text presentation is required.

Attributes:
Name | Data type | Mandatory | Default | Description
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member
xml:lang | String | X |  | The natural or formal language of the tag or its attributes

Nested tags:
<em> <strong> <b> <i> <big> <small> <br> <img> <anchor> <a> <table>


WML tag: <wml>

<wml>

Summary:
The <wml> tag defines a deck and encloses all information and cards in the deck.

Attributes:
Name | Data type | Mandatory | Default | Description
xml:lang | String | X |  | The natural or formal language of the tag or its attributes
id | String | X |  | A unique name for the tag within the deck
class | String | X |  | A name of a class of which the tag is a member

Nested tags:
<head> <template> <card>